using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using IServer;

namespace Klient
{
	/// <summary>
	/// Summary description for Booking.
	/// </summary>
	public class Booking : System.Windows.Forms.Form
	{
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button btnLukVindue;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Label lblNavn;
		private System.Windows.Forms.Label lblFirma;
		private System.Windows.Forms.Label lblTelefon;
		private System.Windows.Forms.Button btnFindGaest;
		private System.Windows.Forms.GroupBox grpBox1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.DataGrid dataGrid1;
		private System.Windows.Forms.Button btnHentLedigeVaerelser;
		private System.Windows.Forms.CheckBox chkB1;
		private System.Windows.Forms.CheckBox chkB2;
		private System.Windows.Forms.CheckBox chkB3;
		private System.Windows.Forms.CheckBox chkB4;
		private System.Windows.Forms.CheckBox chkB5;
		private System.Windows.Forms.CheckBox chkB6;
		private System.Windows.Forms.Button btnBook;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label lblSamletPris;

		private static Booking bb = null;
		private System.Windows.Forms.TextBox txtNavn;
		private System.Windows.Forms.TextBox txtFirma;
		private System.Windows.Forms.TextBox txtTelefon;
		private System.Windows.Forms.DateTimePicker dtpFra;
		private System.Windows.Forms.DateTimePicker dtpTil;
		private GaestObj gaest;

		private DataTable dt;
		private DataTable tmp;

		private bool periodeChanged = false;

		public static void Vis()
		{
			if (bb == null)
			{bb = new Booking();}
			
			bb.SetMinDato();
			bb.Show();
		}
		public static void Vis(GaestObj g)
		{
			if (bb == null)
			{bb = new Booking();}
			
			bb.GaestInfo = g;
			bb.opdaterGaestInfo();
			bb.SetMinDato();
			bb.Show();
		}

		public GaestObj GaestInfo
		{
			set {this.gaest = value;}
		}

		public Booking()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		public void SetMinDato()
		{
			this.dtpTil.MinDate = DateTime.Now;
			this.dtpFra.MinDate = DateTime.Now;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnLukVindue = new System.Windows.Forms.Button();
			this.panel1 = new System.Windows.Forms.Panel();
			this.txtTelefon = new System.Windows.Forms.TextBox();
			this.btnFindGaest = new System.Windows.Forms.Button();
			this.txtFirma = new System.Windows.Forms.TextBox();
			this.txtNavn = new System.Windows.Forms.TextBox();
			this.lblTelefon = new System.Windows.Forms.Label();
			this.lblFirma = new System.Windows.Forms.Label();
			this.lblNavn = new System.Windows.Forms.Label();
			this.grpBox1 = new System.Windows.Forms.GroupBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.dtpFra = new System.Windows.Forms.DateTimePicker();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.dtpTil = new System.Windows.Forms.DateTimePicker();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label3 = new System.Windows.Forms.Label();
			this.btnBook = new System.Windows.Forms.Button();
			this.chkB6 = new System.Windows.Forms.CheckBox();
			this.chkB5 = new System.Windows.Forms.CheckBox();
			this.chkB4 = new System.Windows.Forms.CheckBox();
			this.chkB3 = new System.Windows.Forms.CheckBox();
			this.chkB2 = new System.Windows.Forms.CheckBox();
			this.chkB1 = new System.Windows.Forms.CheckBox();
			this.btnHentLedigeVaerelser = new System.Windows.Forms.Button();
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			this.lblSamletPris = new System.Windows.Forms.Label();
			this.panel1.SuspendLayout();
			this.grpBox1.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// btnLukVindue
			// 
			this.btnLukVindue.Location = new System.Drawing.Point(672, 432);
			this.btnLukVindue.Name = "btnLukVindue";
			this.btnLukVindue.TabIndex = 0;
			this.btnLukVindue.Text = "Luk vindue";
			this.btnLukVindue.Click += new System.EventHandler(this.btnLukVindue_Click);
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.txtTelefon);
			this.panel1.Controls.Add(this.btnFindGaest);
			this.panel1.Controls.Add(this.txtFirma);
			this.panel1.Controls.Add(this.txtNavn);
			this.panel1.Controls.Add(this.lblTelefon);
			this.panel1.Controls.Add(this.lblFirma);
			this.panel1.Controls.Add(this.lblNavn);
			this.panel1.Location = new System.Drawing.Point(8, 16);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(232, 136);
			this.panel1.TabIndex = 1;
			// 
			// txtTelefon
			// 
			this.txtTelefon.Location = new System.Drawing.Point(64, 72);
			this.txtTelefon.Name = "txtTelefon";
			this.txtTelefon.ReadOnly = true;
			this.txtTelefon.Size = new System.Drawing.Size(80, 20);
			this.txtTelefon.TabIndex = 7;
			this.txtTelefon.Text = "";
			// 
			// btnFindGaest
			// 
			this.btnFindGaest.Location = new System.Drawing.Point(144, 104);
			this.btnFindGaest.Name = "btnFindGaest";
			this.btnFindGaest.TabIndex = 6;
			this.btnFindGaest.Text = "Find Gst";
			this.btnFindGaest.Click += new System.EventHandler(this.btnFindGaest_Click);
			// 
			// txtFirma
			// 
			this.txtFirma.Location = new System.Drawing.Point(64, 48);
			this.txtFirma.Name = "txtFirma";
			this.txtFirma.ReadOnly = true;
			this.txtFirma.Size = new System.Drawing.Size(152, 20);
			this.txtFirma.TabIndex = 4;
			this.txtFirma.Text = "";
			// 
			// txtNavn
			// 
			this.txtNavn.Location = new System.Drawing.Point(64, 24);
			this.txtNavn.Name = "txtNavn";
			this.txtNavn.ReadOnly = true;
			this.txtNavn.Size = new System.Drawing.Size(152, 20);
			this.txtNavn.TabIndex = 3;
			this.txtNavn.Text = "";
			// 
			// lblTelefon
			// 
			this.lblTelefon.Location = new System.Drawing.Point(16, 72);
			this.lblTelefon.Name = "lblTelefon";
			this.lblTelefon.Size = new System.Drawing.Size(48, 23);
			this.lblTelefon.TabIndex = 2;
			this.lblTelefon.Text = "Telefon";
			// 
			// lblFirma
			// 
			this.lblFirma.Location = new System.Drawing.Point(16, 48);
			this.lblFirma.Name = "lblFirma";
			this.lblFirma.Size = new System.Drawing.Size(40, 23);
			this.lblFirma.TabIndex = 1;
			this.lblFirma.Text = "Firma";
			// 
			// lblNavn
			// 
			this.lblNavn.Location = new System.Drawing.Point(16, 24);
			this.lblNavn.Name = "lblNavn";
			this.lblNavn.Size = new System.Drawing.Size(40, 23);
			this.lblNavn.TabIndex = 0;
			this.lblNavn.Text = "Navn";
			// 
			// grpBox1
			// 
			this.grpBox1.Controls.Add(this.panel1);
			this.grpBox1.Location = new System.Drawing.Point(8, 8);
			this.grpBox1.Name = "grpBox1";
			this.grpBox1.Size = new System.Drawing.Size(256, 160);
			this.grpBox1.TabIndex = 2;
			this.grpBox1.TabStop = false;
			this.grpBox1.Text = "Gsteinfo";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.dtpFra);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Controls.Add(this.dtpTil);
			this.groupBox1.Location = new System.Drawing.Point(280, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(376, 104);
			this.groupBox1.TabIndex = 3;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Booking periode";
			// 
			// dtpFra
			// 
			this.dtpFra.Location = new System.Drawing.Point(16, 56);
			this.dtpFra.MinDate = new System.DateTime(2004, 10, 21, 0, 0, 0, 0);
			this.dtpFra.Name = "dtpFra";
			this.dtpFra.Size = new System.Drawing.Size(144, 20);
			this.dtpFra.TabIndex = 4;
			this.dtpFra.ValueChanged += new System.EventHandler(this.dtp_ValueChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(200, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 16);
			this.label2.TabIndex = 3;
			this.label2.Text = "Sidste bookingdag";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "Frste bookingdag";
			// 
			// dtpTil
			// 
			this.dtpTil.Location = new System.Drawing.Point(200, 56);
			this.dtpTil.MinDate = new System.DateTime(2004, 10, 21, 0, 0, 0, 0);
			this.dtpTil.Name = "dtpTil";
			this.dtpTil.Size = new System.Drawing.Size(144, 20);
			this.dtpTil.TabIndex = 4;
			this.dtpTil.ValueChanged += new System.EventHandler(this.dtp_ValueChanged);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.label3);
			this.groupBox2.Controls.Add(this.btnBook);
			this.groupBox2.Controls.Add(this.chkB6);
			this.groupBox2.Controls.Add(this.chkB5);
			this.groupBox2.Controls.Add(this.chkB4);
			this.groupBox2.Controls.Add(this.chkB3);
			this.groupBox2.Controls.Add(this.chkB2);
			this.groupBox2.Controls.Add(this.chkB1);
			this.groupBox2.Controls.Add(this.btnHentLedigeVaerelser);
			this.groupBox2.Controls.Add(this.dataGrid1);
			this.groupBox2.Controls.Add(this.lblSamletPris);
			this.groupBox2.Location = new System.Drawing.Point(8, 176);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(648, 288);
			this.groupBox2.TabIndex = 5;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Ledige Vrelser";
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(456, 256);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(80, 24);
			this.label3.TabIndex = 14;
			this.label3.Text = "Samlet pris";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// btnBook
			// 
			this.btnBook.Location = new System.Drawing.Point(152, 256);
			this.btnBook.Name = "btnBook";
			this.btnBook.Size = new System.Drawing.Size(120, 24);
			this.btnBook.TabIndex = 13;
			this.btnBook.Text = "Book vrelse";
			this.btnBook.Click += new System.EventHandler(this.btnBook_Click);
			// 
			// chkB6
			// 
			this.chkB6.Checked = true;
			this.chkB6.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkB6.Location = new System.Drawing.Point(544, 152);
			this.chkB6.Name = "chkB6";
			this.chkB6.Size = new System.Drawing.Size(88, 24);
			this.chkB6.TabIndex = 12;
			this.chkB6.Text = "Dobbelt";
			this.chkB6.CheckedChanged += new System.EventHandler(this.chkB_CheckedChanged);
			// 
			// chkB5
			// 
			this.chkB5.Checked = true;
			this.chkB5.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkB5.Location = new System.Drawing.Point(544, 128);
			this.chkB5.Name = "chkB5";
			this.chkB5.Size = new System.Drawing.Size(88, 24);
			this.chkB5.TabIndex = 11;
			this.chkB5.Text = "Enkelt";
			this.chkB5.CheckedChanged += new System.EventHandler(this.chkB_CheckedChanged);
			// 
			// chkB4
			// 
			this.chkB4.Checked = true;
			this.chkB4.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkB4.Location = new System.Drawing.Point(544, 96);
			this.chkB4.Name = "chkB4";
			this.chkB4.Size = new System.Drawing.Size(88, 24);
			this.chkB4.TabIndex = 10;
			this.chkB4.Text = "Handicap";
			this.chkB4.CheckedChanged += new System.EventHandler(this.chkB_CheckedChanged);
			// 
			// chkB3
			// 
			this.chkB3.Checked = true;
			this.chkB3.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkB3.Location = new System.Drawing.Point(544, 72);
			this.chkB3.Name = "chkB3";
			this.chkB3.Size = new System.Drawing.Size(88, 24);
			this.chkB3.TabIndex = 9;
			this.chkB3.Text = "Ej handicap";
			this.chkB3.CheckedChanged += new System.EventHandler(this.chkB_CheckedChanged);
			// 
			// chkB2
			// 
			this.chkB2.Checked = true;
			this.chkB2.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkB2.Location = new System.Drawing.Point(544, 40);
			this.chkB2.Name = "chkB2";
			this.chkB2.Size = new System.Drawing.Size(88, 24);
			this.chkB2.TabIndex = 8;
			this.chkB2.Text = "Ryger";
			this.chkB2.CheckedChanged += new System.EventHandler(this.chkB_CheckedChanged);
			// 
			// chkB1
			// 
			this.chkB1.Checked = true;
			this.chkB1.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkB1.Location = new System.Drawing.Point(544, 16);
			this.chkB1.Name = "chkB1";
			this.chkB1.Size = new System.Drawing.Size(88, 24);
			this.chkB1.TabIndex = 7;
			this.chkB1.Text = "Ikkeryger";
			this.chkB1.CheckedChanged += new System.EventHandler(this.chkB_CheckedChanged);
			// 
			// btnHentLedigeVaerelser
			// 
			this.btnHentLedigeVaerelser.Location = new System.Drawing.Point(8, 256);
			this.btnHentLedigeVaerelser.Name = "btnHentLedigeVaerelser";
			this.btnHentLedigeVaerelser.Size = new System.Drawing.Size(128, 24);
			this.btnHentLedigeVaerelser.TabIndex = 6;
			this.btnHentLedigeVaerelser.Text = "Hent ledige vrelser";
			this.btnHentLedigeVaerelser.Click += new System.EventHandler(this.btnHentLedigeVaerelser_Click);
			// 
			// dataGrid1
			// 
			this.dataGrid1.AllowSorting = false;
			this.dataGrid1.CaptionVisible = false;
			this.dataGrid1.DataMember = "";
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(8, 16);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(520, 232);
			this.dataGrid1.TabIndex = 5;
			this.dataGrid1.Click += new System.EventHandler(this.dataGrid1_Click);
			// 
			// lblSamletPris
			// 
			this.lblSamletPris.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblSamletPris.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblSamletPris.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
			this.lblSamletPris.Location = new System.Drawing.Point(544, 256);
			this.lblSamletPris.Name = "lblSamletPris";
			this.lblSamletPris.Size = new System.Drawing.Size(72, 24);
			this.lblSamletPris.TabIndex = 14;
			this.lblSamletPris.Text = "0,00";
			this.lblSamletPris.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// Booking
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(760, 470);
			this.ControlBox = false;
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.grpBox1);
			this.Controls.Add(this.btnLukVindue);
			this.Name = "Booking";
			this.Text = "Booking";
			this.panel1.ResumeLayout(false);
			this.grpBox1.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		public void opdaterGaestInfo()
		{
			this.txtNavn.Text = gaest.Navn;
			this.txtFirma.Text = gaest.Firma;
			this.txtTelefon.Text = gaest.TelefonNr;
		}

		private void btnLukVindue_Click(object sender, System.EventArgs e)
		{
			this.Hide();
			StartBillede.Vis();
		}

		private void btnFindGaest_Click(object sender, System.EventArgs e)
		{
			Gaest.Vis();
			this.Hide();
		}

		private void btnHentLedigeVaerelser_Click(object sender, System.EventArgs e)
		{
			if (this.dtpFra.Value <= this.dtpTil.Value)
			{
				dt = HotelConnection.DbFacade.HentLedigeVaerelser(this.dtpFra.Value, this.dtpTil.Value);
				this.dataGrid1.DataSource = dt;
			}
			else
			{
				MessageBox.Show(this,"Sidste bookingdag skal vre den samme eller ligge efter startdatoen.");
			}
			periodeChanged = false;
		}

		private void chkB_CheckedChanged(object sender, System.EventArgs e)
		{
			
			tmp = dt.Copy();
			foreach (DataRow r in tmp.Rows)
			{
				if (!chkB1.Checked && (bool)r[2])
				{r.Delete();}
				else if (!chkB2.Checked && !((bool)r[2]))
				{r.Delete();}
				else if (!chkB3.Checked && !((bool)r[3]))
				{r.Delete();}
				else if (!chkB4.Checked && (bool)r[3])
				{r.Delete();}
				else if (!chkB5.Checked && (int)r[1] == 0)
				{r.Delete();}
				else if (!chkB6.Checked && (int)r[1] == 1)
				{r.Delete();}

			}
			dataGrid1.DataSource = tmp;
		}

		private void btnBook_Click(object sender, System.EventArgs e)
		{
			if (periodeChanged)
			{
				MessageBox.Show(this,"Der er ndret i perioden. Hent ledige vrelser igen.","UPS!!",MessageBoxButtons.OK,MessageBoxIcon.Warning);
			}
			else
			{
				int vaerelsesnr = (int) dataGrid1[dataGrid1.CurrentRowIndex,0];
					//(int)((DataTable)dataGrid1.DataSource).Rows[dataGrid1.CurrentRowIndex][0];
				if (!HotelConnection.DbFacade.GemBooking(gaest.Id,vaerelsesnr,this.dtpFra.Value,this.dtpTil.Value))
				{
					MessageBox.Show(this,"Vrelset er mske allerede blevet booket af en anden","Der skete en fejl ved booking",MessageBoxButtons.OK,MessageBoxIcon.Error);
				}
				else
				{
					MessageBox.Show(this,"Vrelset er nu booket","YAY",MessageBoxButtons.OK,MessageBoxIcon.Information);
				}
			}
		}

		private void dtp_ValueChanged(object sender, System.EventArgs e)
		{
			periodeChanged = true;
		}

		private void dataGrid1_Click(object sender, System.EventArgs e)
		{
			int vaerelsesnr = (int) dataGrid1[dataGrid1.CurrentRowIndex,0];
			TimeSpan t = this.dtpTil.Value - this.dtpFra.Value;
			lblSamletPris.Text = (HotelConnection.DbFacade.FindVaerelse(vaerelsesnr).Pris*t.Days).ToString();
		}

		
	}
}
